package de.frajul.endlessroll.main.screens;

import android.view.View;
import android.widget.LinearLayout;
import android.widget.TextView;

import java.util.HashMap;
import java.util.Map;

import de.frajul.endlessroll.R;
import de.frajul.endlessroll.levels.Level;
import de.frajul.endlessroll.levels.LevelPack;
import de.frajul.endlessroll.main.GameActivity;
import de.frajul.endlessroll.main.game.Game;
import de.frajul.endlessroll.views.LevelButton;
import de.frajul.endlessroll.views.LevelButtonOnClickListener;
import de.frajul.endlessroll.views.TopBar;

/**
 * Created by Julian on 23.04.2016.
 */
public class GoalScreen extends Screen<LinearLayout> implements LevelButtonOnClickListener {

    private LevelPack levelPack;

    private TopBar topBar;
    private TextView title;
    private LevelButton restart;
    private LevelButton nextLevel;

    public GoalScreen(GameActivity gameActivity) {
        super(ScreenType.GOAL, gameActivity, R.layout.goal_screen);
        topBar = super.createTopBar(R.id.goal_screen_topbar);
        title = (TextView) layout.findViewById(R.id.goal_screen_title);
        title.setTypeface(gameActivity.getTypeface());
        restart = new LevelButton(gameActivity, this, layout.findViewById(R.id.goal_screen_restart));
        nextLevel = new LevelButton(gameActivity, this, layout.findViewById(R.id.goal_screen_next_level));
    }

    public void onLevelFinished(LevelPack levelPack, Level level){
        this.levelPack = levelPack;
        restart.init(level);
        nextLevel.init(levelPack.getNextLevel(level));
    }

    @Override
    public void prepareToBeShown() {
        topBar.update();
    }

    @Override
    public void onBackKeyDown() {
        flipTo(ScreenType.LEVELS);
    }

    @Override
    public void onClick(LevelButton levelButton) {
        gameActivity.startGame(levelPack, levelButton.getLevel());
    }
}
